package org.beigesoft.web.service;

/*
 * Copyright (c) 2018 Beigesoft ™
 *
 * Licensed under the GNU General Public License (GPL), Version 2.0
 * (the "License");
 * you may not use this file except in compliance with the License.
 *
 * You may obtain a copy of the License at
 *
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.en.html
 */

import javax.servlet.http.HttpServletRequest;

/**
 * <p>Service that tracks sessions.</p>
 * @author Yury Demidenko
 */
public interface ISessionTracker {

  /**
   * <p>Tracks new session if need.</p>
   * @param pReq HTTP request
   * @throws Exception - an exception
   **/
  void trackNewIfNeed(HttpServletRequest pReq) throws Exception;

  /**
   * <p>Tracks login fail.</p>
   * @param pReq HTTP request
   * @throws Exception - an exception
   **/
  void trackLoginFail(HttpServletRequest pReq) throws Exception;
}
