package org.beigesoft.web.servlet;

/*
 * Copyright (c) 2018 Beigesoft ™
 *
 * Licensed under the GNU General Public License (GPL), Version 2.0
 * (the "License");
 * you may not use this file except in compliance with the License.
 *
 * You may obtain a copy of the License at
 *
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.en.html
 */

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.beigesoft.exception.ExceptionWithCode;
import org.beigesoft.web.service.SrvAddTheFirstUser;

/**
 * <p>Servlet that change user password.
 * For LOCALHOST only!</p>
 * @author Yury Demidenko
 */
@SuppressWarnings("serial")
public class WChangeUserPasswd extends HttpServlet {

  @Override
  public final void doPost(final HttpServletRequest pReq,
    final HttpServletResponse pResp) throws ServletException, IOException {
    pReq.setCharacterEncoding("UTF-8");
    pResp.setCharacterEncoding("UTF-8");
    try {
      @SuppressWarnings("rawtypes")
      SrvAddTheFirstUser srvAddFiU = (SrvAddTheFirstUser) getServletContext()
        .getAttribute("srvAddTheFirstUser");
      String userName = pReq.getParameter("userName");
      String userPassOld = pReq.getParameter("userPassOld");
      String userPass = pReq.getParameter("userPass");
      String userPassRep = pReq.getParameter("userPassRep");
      String jsp = "/secure/changePasswdFirstUser.jsp";
      if (userName == null) {
        pReq.setAttribute("passwErrMsg", "enterName");
      } else if (userPassOld != null && userPassOld.equals(userPass)) {
        pReq.setAttribute("passwErrMsg", "pass_new_same_old");
      } else if (userPass == null) {
        pReq.setAttribute("passwErrMsg", "passwNotStrong");
      } else if (!userPass.equals(userPassRep)) {
        pReq.setAttribute("passwErrMsg", "repeatPasswNotMatch");
      } else if (userPass.contains(userName)) {
        pReq.setAttribute("passwErrMsg", "passwMustNoContainName");
      } else {
        String chkps = srvAddFiU.isPasswordStrong(userPass.toCharArray());
        if (chkps != null) {
          pReq.setAttribute("passwErrMsg", chkps);
        } else {
          if (!srvAddFiU.changeUserPasswd(userName, userPass, userPassOld)) {
            pReq.setAttribute("passwErrMsg", "invalid_user_name_or_password");
          } else {
            jsp = "/secure/main.jsp";
            pReq.getSession().invalidate();
          }
        }
      }
      RequestDispatcher rd = getServletContext().getRequestDispatcher(jsp);
      rd.include(pReq, pResp);
    } catch (Exception e) {
      e.printStackTrace();
      if (e instanceof ExceptionWithCode) {
        pReq.setAttribute("error_code",
          ((ExceptionWithCode) e).getCode());
        pReq.setAttribute("short_message",
          ((ExceptionWithCode) e).getShortMessage());
      } else {
        pReq.setAttribute("error_code",
          HttpServletResponse.SC_INTERNAL_SERVER_ERROR);
      }
      pReq.setAttribute("javax.servlet.error.status_code",
        HttpServletResponse.SC_INTERNAL_SERVER_ERROR);
      pReq.setAttribute("javax.servlet.error.exception", e);
      pReq.setAttribute("javax.servlet.error.request_uri",
        pReq.getRequestURI());
      pReq.setAttribute("javax.servlet.error.servlet_name", this.getClass()
        .getCanonicalName());
      pResp.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR);
    }
  }
}
